<!DOCTYPE html>

<html lang="en" data-content_root="../../../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>sagace.auth.interfaces.authentication_service &#8212; sagace 2025 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../../../_static/pygments.css?v=5ecbeea2" />
    <link rel="stylesheet" type="text/css" href="../../../../_static/basic.css?v=b08954a9" />
    <link rel="stylesheet" type="text/css" href="../../../../_static/alabaster.css?v=27fed22d" />
    <script src="../../../../_static/documentation_options.js?v=cb975c41"></script>
    <script src="../../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
   
  <link rel="stylesheet" href="../../../../_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for sagace.auth.interfaces.authentication_service</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">--------------------------------------------------------------------------------------------------------------------</span>

<span class="sd">Descrição:</span>
<span class="sd">~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>

<span class="sd">Este módulo fornece um serviço de autenticação para facilitar o uso do sistema SAGACE.</span>
<span class="sd">A classe `AuthenticationService` encapsula a lógica de autenticação, delegando o processo</span>
<span class="sd">para a classe de caso de uso `AuthenticateUser`, que por sua vez utiliza `AuthenticationAPI`.</span>

<span class="sd">Principais funcionalidades:</span>

<span class="sd">- Abstrai a autenticação de usuários, simplificando a interface.</span>
<span class="sd">- Delegação do fluxo de autenticação conforme o princípio **Single Responsibility** (S - SOLID).</span>
<span class="sd">- Facilita a reutilização da lógica de autenticação em diferentes partes do sistema.</span>

<span class="sd">Classes:</span>

<span class="sd">- ``AuthenticationService``: Serviço de autenticação de usuários.</span>

<span class="sd">Exemplo de uso:</span>

<span class="sd">.. code-block:: python</span>

<span class="sd">    from sagace.application import AuthenticationService</span>
<span class="sd">    from sagace.core import TokenStorage</span>

<span class="sd">    service = AuthenticationService()</span>
<span class="sd">    token_storage = TokenStorage()</span>
<span class="sd">    token = service.login(&quot;https://api.sagace.online&quot;, &quot;usuario&quot;, &quot;senha&quot;, &quot;app_token&quot;, token_storage)</span>
<span class="sd">    print(token)</span>


<span class="sd">Autor: Diego Yosiura</span>
<span class="sd">Última Atualização: 27/02/2025 15:32</span>
<span class="sd">Criado em: 27/02/2025 15:32</span>
<span class="sd">Copyright: (c) Ampere Consultoria Ltda</span>
<span class="sd">Projeto Original: sagace-v2-package</span>
<span class="sd">IDE: PyCharm</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span><span class="w"> </span><span class="nn">..infrastructure.authentication_api</span><span class="w"> </span><span class="kn">import</span> <span class="n">AuthenticationAPI</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">..application</span><span class="w"> </span><span class="kn">import</span> <span class="n">AuthenticateUser</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">...core</span><span class="w"> </span><span class="kn">import</span> <span class="n">TokenStorage</span>


<div class="viewcode-block" id="AuthenticationService">
<a class="viewcode-back" href="../../../../sagace.auth.interfaces.html#sagace.auth.interfaces.authentication_service.AuthenticationService">[docs]</a>
<span class="k">class</span><span class="w"> </span><span class="nc">AuthenticationService</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Serviço de autenticação para facilitar o uso do sistema.</span>

<span class="sd">    Esta classe abstrai a autenticação de usuários, centralizando o fluxo em `AuthenticateUser`.</span>
<span class="sd">    Segue o princípio **Dependency Inversion (D - SOLID)**, garantindo que a implementação de</span>
<span class="sd">    autenticação possa ser alterada sem impactar os consumidores do serviço.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span><span class="w"> </span><span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Inicializa o serviço de autenticação.</span>

<span class="sd">        O repositório de autenticação `AuthenticationAPI` é injetado na instância de `AuthenticateUser`,</span>
<span class="sd">        garantindo que qualquer mudança na lógica de autenticação possa ser realizada de forma desacoplada.</span>

<span class="sd">        Princípios aplicados:</span>
<span class="sd">        - **Dependency Inversion (D - SOLID)**: A classe depende de uma abstração, permitindo substituição.</span>
<span class="sd">        - **Single Responsibility (S - SOLID)**: Centraliza a autenticação sem lidar com detalhes internos da API.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">use_case</span> <span class="o">=</span> <span class="n">AuthenticateUser</span><span class="p">(</span><span class="n">auth_repository</span><span class="o">=</span><span class="n">AuthenticationAPI</span><span class="p">())</span>

<div class="viewcode-block" id="AuthenticationService.login">
<a class="viewcode-back" href="../../../../sagace.auth.interfaces.html#sagace.auth.interfaces.authentication_service.AuthenticationService.login">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">login</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">base_url</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">username</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">password</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">application_token</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
              <span class="n">token_storage</span><span class="p">:</span> <span class="n">TokenStorage</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Realiza login e retorna o token JWT.</span>

<span class="sd">        :param base_url: URL base da API de autenticação.</span>
<span class="sd">        :type base_url: str</span>
<span class="sd">        :param username: Nome de usuário para autenticação.</span>
<span class="sd">        :type username: str</span>
<span class="sd">        :param password: Senha do usuário.</span>
<span class="sd">        :type password: str</span>
<span class="sd">        :param application_token: Token da aplicação para autenticação.</span>
<span class="sd">        :type application_token: str</span>
<span class="sd">        :param token_storage: Instância responsável por armazenar o token JWT.</span>
<span class="sd">        :type token_storage: TokenStorage</span>
<span class="sd">        :return: Token de autenticação JWT.</span>
<span class="sd">        :rtype: str</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="c1"># Chama a camada de aplicação para realizar a autenticação</span>
        <span class="n">token</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">use_case</span><span class="o">.</span><span class="n">execute</span><span class="p">(</span><span class="n">base_url</span><span class="p">,</span> <span class="n">username</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">application_token</span><span class="p">,</span> <span class="n">token_storage</span><span class="p">)</span>

        <span class="c1"># Retorna apenas o token de acesso</span>
        <span class="k">return</span> <span class="n">token</span><span class="o">.</span><span class="n">access_token</span></div>
</div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="Main">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../../index.html">sagace</a></h1>









<search id="searchbox" style="display: none" role="search">
    <div class="searchformwrapper">
    <form class="search" action="../../../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" placeholder="Search"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</search>
<script>document.getElementById('searchbox').style.display = "block"</script><h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Conteúdo:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../modules.html">sagace</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../../index.html">Documentation overview</a><ul>
  <li><a href="../../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2025, Ampere Consultoria.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 8.2.1</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 1.0.0</a>
      
    </div>

    

    
  </body>
</html>